function dlnet=layersNewCombined_without_MLP(inputSize,dropRate,regSize)
if nargin==1
    dropRate=.25;
    regSize=1;
end
if nargin==2
    regSize=1;
end







lgraph = layerGraph();

tempLayers = sequenceInputLayer(inputSize,"Name","sequenceinput");
lgraph = addLayers(lgraph,tempLayers);

tempLayers = [
    lstmLayer(128,"Name","lstm_1")
    lstmLayer(64,"Name","lstm_2","OutputMode","last")
    fullyConnectedLayer(64,"Name","fc_1_z1")
    dropoutLayer(dropRate,"Name","dropout_21")
    myReshapeLayer(8,8,"mreshape21")
    convolution2dLayer([3 3],8,"Name","conv21","Padding","same")
    %     flattenLayer("Name","mFlatten21")
    fullyConnectedLayer(64,"Name","fc_1_11")
    fullyConnectedLayer(32,"Name","fc_2_21")];
lgraph = addLayers(lgraph,tempLayers);

tempLayersG = [
    gruLayer( 128, 'OutputMode', 'sequence', ...
    "Name", "gruG1")
    concatenationLayer(1, 2, "Name", "catg1")
    gruLayer( 64, 'OutputMode', 'last', ...
    "Name", "gruG3")
    concatenationLayer(1, 2, "Name", "catg2")
    fullyConnectedLayer(64, 'Name', 'fc_g1')
    fullyConnectedLayer(32, 'Name', 'fc_g2')
    ];
lgraph = addLayers(lgraph,tempLayersG);
tempLayersG2 =[FlipLayer("flip1")
    gruLayer( 128, 'OutputMode', 'sequence', ...
    "Name", "gruG2" )
    FlipLayer("flip2")];
lgraph = addLayers(lgraph,tempLayersG2);
tempLayersG3=[FlipLayer("flip3")
    gruLayer( 64, 'OutputMode', 'last', ...
    "Name", "gruG4" )];
lgraph = addLayers(lgraph,tempLayersG3);
lgraph = connectLayers(lgraph,"sequenceinput","gruG1");
lgraph = connectLayers(lgraph,"sequenceinput","flip1");
lgraph = connectLayers(lgraph, "flip2", "catg1/in2");
lgraph = connectLayers(lgraph, "catg1", "flip3");
lgraph = connectLayers(lgraph, "gruG4", "catg2/in2");
% lg = connectLayers(lg, "sequenceinput", "flip1");
% lg = connectLayers(lg, "flip2", "cat1/in2");
% lg = connectLayers(lg, "cat1", "flip3");
% lg = connectLayers(lg, "gru4", "cat2/in2");

tempLayers = [
    gruLayer(128,"Name","gru")
    gruLayer(64,"Name","gru1","OutputMode","last")
    fullyConnectedLayer(64,"Name","fc_1_z")
    dropoutLayer(dropRate,"Name","dropout_2")
    myReshapeLayer(8,8,"mreshape2")
    convolution2dLayer([3 3],8,"Name","conv2","Padding","same")
    %     flattenLayer("Name","mFlatten2")
    fullyConnectedLayer(64,"Name","fc_1_1")
    fullyConnectedLayer(32,"Name","fc_2_2")];
lgraph = addLayers(lgraph,tempLayers);

tempLayers = [
    bilstmLayer(256,"Name","biLSTM_1")
    bilstmLayer(512,"Name","biLSTM_2","OutputMode","last")
    fullyConnectedLayer(1024,"Name","fc_z")
    dropoutLayer(dropRate,"Name","dropout")
    myReshapeLayer(32,32,"mreshape1")
    convolution2dLayer([3 3],8,"Name","conv","Padding","same")
    reluLayer("Name","relu1")
    %     flattenLayer("Name","mFlatten")
    fullyConnectedLayer(64,"Name","fc_1")
    reluLayer("Name","relu")
    fullyConnectedLayer(32,"Name","fc_2_1")];
lgraph = addLayers(lgraph,tempLayers);

tempLayers = [
    concatenationLayer(1,4,"Name","concat")
    fullyConnectedLayer(regSize,"Name","fc_3")];
%     regressionLayer("Name","regressionoutput")];
lgraph = addLayers(lgraph,tempLayers);

% clean up helper variable
clear tempLayers;
%% Connect Layer Branches
% Connect all the branches of the network to create the network graph.

lgraph = connectLayers(lgraph,"sequenceinput","lstm_1");
lgraph = connectLayers(lgraph,"sequenceinput","gru");
lgraph = connectLayers(lgraph,"sequenceinput","biLSTM_1");
lgraph = connectLayers(lgraph,"fc_2_21","concat/in3");
lgraph = connectLayers(lgraph,"fc_2_1","concat/in1");
lgraph = connectLayers(lgraph,"fc_2_2","concat/in2");
lgraph = connectLayers(lgraph,"fc_g2","concat/in4");



% lgraph = addLayers(lgraph,tempLayers2);
% lgraph = addLayers(lgraph,featInput);
% lgraph = connectLayers(lgraph,"fc_1_1f2","concat/in4");
dlnet = dlnetwork(lgraph);