classdef myReshapeLayer < nnet.layer.Layer  & nnet.layer.Formattable
    % gaussianNoiseLayer   Gaussian noise layer
    %   A Gaussian noise layer adds random Gaussian noise to the input.
    %
    %   To create a Gaussian noise layer, use
    %   layer = gaussianNoiseLayer(sigma, name)
    
    properties
        % Standard deviation.
        Size1
        Size2
    end
%     properties (Learnable)
%     end
    methods
        function layer = myReshapeLayer(size1,size2, name)
            % layer = gaussianNoiseLayer(sigma,name) creates a Gaussian
            % noise layer and specifies the standard deviation and layer
            % name.
            
            layer.Name = name;
            layer.Description = ...
                "Gaussian noise with standard deviation ";
            layer.Type = "Reshape Layer";
            layer.Size1 = size1;
            layer.Size2 = size2;
            
        end
        
        function Z = predict(layer, X)
            % Z = predict(layer, X) forwards the input data X through the
            % layer for prediction and outputs the result Z.
            
            % At prediction time, the output is equal to the input.
%             ll=size(X,1);
            Z = reshape(X,layer.Size1,layer.Size2,1,[]);
            Z = dlarray(Z,'SSCB');
        end
        
%         function Z = forward(layer, X)
%             % Z = forward(layer, X) forwards the input data X through the
%             % layer and outputs the result Z.
%             
%             % At training time, the layer adds Gaussian noise to the input.
%             %             sigma = layer.Sigma;
%             %             noise = randn(size(X)) * sigma;
%             %             Z = X + noise;
%             Z = reshape(X,layer.Size1,layer.Size1,[]);
%             Z = dlarray(Z,'SSCB');
% %             memory = [];
%         end
        
%         function dLdX = backward(layer, X, Z, dLdZ, memory)
%             % [dLdX, dLdAlpha] = backward(layer, X, Z, dLdZ, memory)
%             % backward propagates the derivative of the loss function
%             % through the layer.
%             
%             % Since the layer adds a random constant, the derivative dLdX
%             % is equal to dLdZ.
%             dLdX = dLdZ;
%         end
    end
end