%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Purpose: Run trained PCG classifier and obtain classifier outputs
% Inputs:
% 1. header
% 2. recordings
% 3. trained model
%
% Outputs:
% 1. score
% 2. label
% 3. classes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [score, label, classes] = team_testing_code(header, recordings, loaded_model)

% classes_murmur=loaded_model.classes_murmur;
% classes_outcome=loaded_model.classes_outcome;

% features=get_features(header,recordings);

% [label_tmp_murmur,score_murmur]=loaded_model.model_murmur.predict(features);
% label_murmur=zeros(1,length(classes_murmur));
% label_murmur(strmatch(label_tmp_murmur,classes_murmur))=1;
%
% [label_tmp_outcome,score_outcome]=loaded_model.model_outcome.predict(features);
% label_outcome=zeros(1,length(classes_outcome));
% label_outcome(strmatch(label_tmp_outcome,classes_outcome))=1;

% classes=[classes_murmur classes_outcome];
% score=[score_murmur score_outcome];
%
% label=[label_murmur label_outcome];
%% here
classes_murmur=loaded_model.classes_murmur;
classes_outcome=loaded_model.classes_outcome;
% loaded_model.model_murmur
[features,locations]=get_features(header,recordings);
models=loaded_model.model_murmur;
modelsO=loaded_model.model_outcome;

snA=models{11};sn=models{12};
modelAV=models{1};modelMV=models{2};
modelPV=models{3};modelTV=models{4};
modelAll=models{5};modelAllT=models{6};
dnet1A=models{7};dnet2A=models{8};
dnet1=models{9};dnet2=models{10};
meanDataSignals=models{13};stdDataSignals=models{14};

snAo=modelsO{11};sno=modelsO{12};
modelAVo=modelsO{1};modelMVo=modelsO{2};
modelPVo=modelsO{3};modelTVo=modelsO{4};
modelAllo=modelsO{5};modelAllTo=modelsO{6};
dnet1Ao=modelsO{7};dnet2Ao=modelsO{8};
dnet1o=modelsO{9};dnet2o=modelsO{10};
%1:AV,2:MV,3:PV,4:TV,5:All,6:All with
%types,7:net1A,8:net2A,9:netB1,10:netB2,11:snA,12:sn

featureVectors=[];
scores=[];
signals={};
types=zeros(length(recordings),5);
scoreFromEnsemblesAll=zeros(length(recordings),1);
oscoreFromEnsemblesAll=zeros(length(recordings),1);

for i=1:length(recordings)
    corrs=myAutoCorrelationSetNew(recordings{i});
    %recordings{i}=findLowest1sec(recordings{i});
    featureVector = challengeTest(recordings{i});
    signals{i}=recordings{i};
    vec=[featureVector,features,corrs];
    vec(isnan(vec))=0;
    vec(isinf(vec))=1e10;
    vec(vec>1e10)=1e10;
    %         current_features=[current_featuresO,corrs];
    featureVectors=[featureVectors;vec];
    if strmatch(locations{i},'AV')
        types(i,5)=1;
        modelz1=modelAV;
        modelz1o=modelAVo;
    end
    if strmatch(locations{i},'Phc')
        types(i,1)=1;
        modelz1=modelAll;
        modelz1o=modelAllo;
    end
    if strmatch(locations{i},'MV')
        types(i,4)=1;
        modelz1=modelMV;
        modelz1o=modelMVo;
    end
    if strmatch(locations{i},'PV')
        types(i,2)=1;
        modelz1=modelPV;
        modelz1o=modelPVo;
    end
    if strmatch(locations{i},'TV')
        types(i,3)=1;
        modelz1=modelTV;
        modelz1o=modelTVo;
    end
    vecT=[vec,types(i,:)];
    scoreFromEnsembles=modelz1.predict(vec)/3+modelAll.predict(vec)/3+modelAllT.predict(vecT)/3;
    %     scoreFromEnsembles=scoreFromEnsembles/2;
    scoreFromEnsemblesAll(i)=scoreFromEnsembles;
    
    oscoreFromEnsembles=modelz1o.predict(vec)/3+modelAllo.predict(vec)/3+modelAllTo.predict(vecT)/3;
    %     oscoreFromEnsembles=oscoreFromEnsembles/2;
    oscoreFromEnsemblesAll(i)=oscoreFromEnsembles;
end
SomeFeatures=[featureVectors,types];

predictions=prepareSignalsForNetPrediction(signals,SomeFeatures,dnet1A,dnet2A,dnet1,dnet2,sn,meanDataSignals,stdDataSignals);
opredictions=prepareSignalsForNetPrediction(signals,SomeFeatures,dnet1Ao,dnet2Ao,dnet1o,dnet2o,snAo,meanDataSignals,stdDataSignals);
predictions=double(gather(extractdata(predictions)));
opredictions=double(gather(extractdata(opredictions)));
% predictions(predictions>1)=.99;
% opredictions(opredictions>1)=.99;

scores=predictions*.5+scoreFromEnsemblesAll*.5;
scores(scores>1)=1;
oscores=opredictions*.5+oscoreFromEnsemblesAll*.5;
oscores(oscores>1)=1;


score=mean(scores);
oscore=mean(oscores);
thresh=0.37;
othresh=0.49;
label_murmur=zeros(1,length(classes_murmur));
label_outcome=zeros(1,length(classes_outcome));

if score>thresh
    label_murmur(2)=1;
else
    label_murmur(1)=1;
end
score=[1-score,score,0];
score_murmur=score;

if oscore>othresh
    label_outcome(1)=1;
else
    label_outcome(2)=1;
end
oscore=[oscore,1-oscore];
score_outcome=oscore;
classes=[classes_murmur classes_outcome];
score=[score_murmur score_outcome];
label=[label_murmur label_outcome];
end
