function model = team_training_code(input_directory,output_directory) % train_PCG_classifier
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Purpose: Train PCG classifiers and obtain the models
% Inputs:
% 1. input_directory
% 2. output_directory
%
% Outputs:
% 1. model: trained model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Find text files
patient_files=dir(fullfile(input_directory,'*.txt'));
patient_files={patient_files.name};
patient_files=sort(patient_files); % To help debugging
num_patient_files=length(patient_files);
noFeatures=2012;
fprintf('Loading data for %d patients...\n', num_patient_files)

classes_murmur={};
classes_outcome={};
for j=1:num_patient_files
    
    current_class_murmur=get_class_murmur(fullfile(input_directory,patient_files{j}));
    classes_murmur=unique([classes_murmur current_class_murmur]);
    
    current_class_outcome=get_class_outcome(fullfile(input_directory,patient_files{j}));
    classes_outcome=unique([classes_outcome current_class_outcome]);
    
end

classes_murmur=sort(classes_murmur);
num_classes_murmur=length(classes_murmur);

classes_outcome=sort(classes_outcome);
num_classes_outcome=length(classes_outcome);
% Extract classes from data
classes={};
nfilesTotal=[];
Strs=['AV';'MV';'TV';'PV';'Ph'];
PatientsAV=zeros(1,num_patient_files);
PatientsMV=zeros(1,num_patient_files);
PatientsTV=zeros(1,num_patient_files);
PatientsPh=zeros(1,num_patient_files);
PatientsPV=zeros(1,num_patient_files);

oOutsAV=-1*ones(1,num_patient_files);
oOutsMV=-1*ones(1,num_patient_files);
oOutsTV=-1*ones(1,num_patient_files);
oOutsPh=-1*ones(1,num_patient_files);
oOutsPV=-1*ones(1,num_patient_files);

OutsAV=-1*ones(1,num_patient_files);
OutsMV=-1*ones(1,num_patient_files);
OutsTV=-1*ones(1,num_patient_files);
OutsPh=-1*ones(1,num_patient_files);
OutsPV=-1*ones(1,num_patient_files);

dataSourcesAV=-1*ones(1,num_patient_files);
dataSourcesMV=-1*ones(1,num_patient_files);
dataSourcesTV=-1*ones(1,num_patient_files);
dataSourcesPV=-1*ones(1,num_patient_files);
% dataSourcesPh=-1*ones(1,942);


featuresAV=zeros(num_patient_files,noFeatures);
featuresMV=zeros(num_patient_files,noFeatures);
featuresTV=zeros(num_patient_files,noFeatures);
featuresPV=zeros(num_patient_files,noFeatures);

featuresPh=zeros(100,noFeatures);


featuresAVsignal=cell(num_patient_files,1);
featuresMVsignal=cell(num_patient_files,1);
featuresTVsignal=cell(num_patient_files,1);
featuresPVsignal=cell(num_patient_files,1);

featuresPhsignal=cell(num_patient_files,1);

tic
kav=0;
kpv=0;
ktv=0;
kmv=0;
kph=0;
disp('Extracting features and labels...')
for j=1:num_patient_files
    j
    strName=[patient_files{j}(1:end-4),'*.wav'];
    current_header=get_header(fullfile(input_directory,patient_files{j}));
    current_recordings=load_recordings(input_directory,current_header);
    campaign=get_campaign(current_header);
    
    
    
    
    
    [current_features,locations]=get_features(current_header, current_recordings);
    
    %     cpatient_file=dir(fullfile(input_directory);
    cpatient_files=dir(fullfile(input_directory,strName));
    nfiles=length(cpatient_files);
    current_class_murmur=get_class_murmur(fullfile(input_directory,patient_files{j}));
    
    %         labels_murmur(j)=get_class_murmur(fullfile(input_directory,patient_files{j}));
    current_class_outcome=get_class_outcome(fullfile(input_directory,patient_files{j}));
    
    current_class_murmur
    zclass=0;
    if strcmp(current_class_murmur,'Present')==1
        zclass=1;
    else
        if strcmp(current_class_murmur,'Unknown')==1
            zclass=2;
        end
    end
    
    oclass=0;
    if strcmp(current_class_outcome,'Abnormal')==1
        oclass=1;
    end
    
    current_featuresO=current_features;
    for k=1:length(current_recordings)
        cfile=[input_directory,cpatient_files(k).name];
        %         current_recordings{k}=findLowest1sec2(current_recordings{k});
        corrs=myAutoCorrelationSetNew(current_recordings{k});
        
        current_features=[current_featuresO,corrs];
        features=challengeTest(current_recordings{k});
        if strfind(locations{k},'AV')
            kav=kav+1;
            featuresAV(kav,:)=[features,current_features];
            OutsAV(kav)=zclass;
            oOutsAV(kav)=oclass;
            featuresAVsignal{kav}=current_recordings{k};
            PatientsAV(kav)=str2num( patient_files{j}(1:end-4));
            dataSourcesAV(kav)=campaign;
        end
        if strfind(locations{k},'TV')
            ktv=ktv+1;
            featuresTVsignal{ktv}=current_recordings{k};
            featuresTV(ktv,:)=[features,current_features];
            OutsTV(ktv)=zclass;
            oOutsTV(ktv)=oclass;
            
            PatientsTV(ktv)=str2num( patient_files{j}(1:end-4));
            dataSourcesTV(ktv)=campaign;
        end
        if strfind(locations{k},'MV')
            kmv=kmv+1;
            featuresMVsignal{kmv}=current_recordings{k};
            featuresMV(kmv,:)=[features,current_features];
            OutsMV(kmv)=zclass;
            oOutsMV(kmv)=oclass;
            
            PatientsMV(kmv)=str2num(patient_files{j}(1:end-4));
            dataSourcesMV(kmv)=campaign;
            
        end
        if strfind(locations{k},'PV')
            kpv=kpv+1;
            featuresPVsignal{kpv}=current_recordings{k};
            featuresPV(kpv,:)=[features,current_features];
            OutsPV(kpv)=zclass;
            oOutsPV(kpv)=oclass;
            
            PatientsPV(kpv)=str2num( patient_files{j}(1:end-4));
            dataSourcesPV(kpv)=campaign;
        end
        if strfind(locations{k},'Ph')
            kph=kph+1;
            featuresPh(kph,:)=[features,current_features];
            OutsPh(kph)=zclass;
            oOutsPh(kph)=oclass;
            featuresPhsignal{kph}=current_recordings{k};
            PatientsPh(kph)=str2num( patient_files{j}(1:end-4));
        end
        
        %         [PCG, Fs1]         = audioread([recordName '.wav']);  % load data
        %         PCG_resampled      = resample(PCG,1000,Fs1);
    end
    
    if nfiles~=4
        [cpatient_files.name," ", num2str(nfiles)]
        zz=1;
    end
    nfilesTotal=[nfilesTotal,nfiles];
    
    classes=unique([classes current_class_murmur]);
end

ff=find(PatientsAV==0);numberAv=ff(1)-1;
ff=find(PatientsTV==0);numberTv=ff(1)-1;
ff=find(PatientsPV==0);numberPv=ff(1)-1;
ff=find(PatientsMV==0);numberMv=ff(1)-1;
ff=find(PatientsPh==0);numberPh=ff(1)-1;
dataSourcesAV=dataSourcesAV(1:numberAv);
dataSourcesPV=dataSourcesPV(1:numberPv);
dataSourcesTV=dataSourcesTV(1:numberTv);
dataSourcesMV=dataSourcesMV(1:numberMv);

PatientsAV=PatientsAV(1:numberAv);
PatientsPV=PatientsPV(1:numberPv);
PatientsTV=PatientsTV(1:numberTv);
PatientsMV=PatientsMV(1:numberMv);
PatientsPh=PatientsPh(1:numberPh);

OutsAV=OutsAV(1:numberAv);
OutsPV=OutsPV(1:numberPv);
OutsTV=OutsTV(1:numberTv);
OutsMV=OutsMV(1:numberMv);
OutsPh=OutsPh(1:numberPh);

oOutsAV=oOutsAV(1:numberAv);
oOutsPV=oOutsPV(1:numberPv);
oOutsTV=oOutsTV(1:numberTv);
oOutsMV=oOutsMV(1:numberMv);
oOutsPh=oOutsPh(1:numberPh);

featuresPh=featuresPh(1:numberPh,:);
featuresPV=featuresPV(1:numberPv,:);
featuresTV=featuresTV(1:numberTv,:);
featuresMV=featuresMV(1:numberMv,:);
featuresAV=featuresAV(1:numberAv,:);
% nCycles=501;
featuresAV(isnan(featuresAV))=0;
featuresAV(isinf(featuresAV))=1e10;featuresAV(featuresAV>1e10)=1e10;
featuresPV(isnan(featuresPV))=0;
featuresPV(isinf(featuresPV))=1e10;featuresPV(featuresPV>1e10)=1e10;
featuresMV(isnan(featuresMV))=0;
featuresMV(isinf(featuresMV))=1e10;featuresMV(featuresMV>1e10)=1e10;
featuresTV(isnan(featuresTV))=0;
featuresTV(isinf(featuresTV))=1e10;featuresTV(featuresTV>1e10)=1e10;

OutsAV(OutsAV>1)=1;
OutsPV(OutsPV>1)=1;
OutsMV(OutsMV>1)=1;
OutsTV(OutsTV>1)=1;
OutsPh(OutsPh>1)=1;

oOutsAV(oOutsAV>1)=1;
oOutsPV(oOutsPV>1)=1;
oOutsMV(oOutsMV>1)=1;
oOutsTV(oOutsTV>1)=1;
oOutsPh(oOutsPh>1)=1;

featuresPhsignal=featuresPhsignal(1:numberPh);
featuresPVsignal=featuresPVsignal(1:numberPv);
featuresTVsignal=featuresTVsignal(1:numberTv);
featuresMVsignal=featuresMVsignal(1:numberMv);
featuresAVsignal=featuresAVsignal(1:numberAv);

% save('allDataNew_All_with_signals1')
nCycles=303;
totalSize=length(featuresPhsignal)+length(featuresPVsignal)+length(featuresTVsignal)+length(featuresMVsignal)+length(featuresAVsignal);
dataAllsignals=cell(totalSize,1);
types=zeros(totalSize,5);
SomeFeatures=zeros(totalSize,noFeatures);
OutsAll=zeros(totalSize,1);
oOutsAll=zeros(totalSize,1);
patientsAll=zeros(totalSize,1);

ki=0;
for i=1:length(featuresPhsignal)
    types(i+ki,1)=1;
    dataAllsignals{i+ki}=featuresPhsignal{i};
    SomeFeatures(i+ki,:)=featuresPh(i,:);
    OutsAll(i+ki)=OutsPh(i);
    oOutsAll(i+ki)=oOutsPh(i);
    patientsAll(i+ki)=PatientsPh(i);
end
ki=ki+length(featuresPhsignal);
for i=1:length(featuresPVsignal)
    types(i+ki,2)=1;
    dataAllsignals{i+ki}=featuresPVsignal{i};
    SomeFeatures(i+ki,:)=featuresPV(i,:);
    OutsAll(i+ki)=OutsPV(i);
    oOutsAll(i+ki)=oOutsPV(i);
    patientsAll(i+ki)=PatientsPV(i);
end
ki=ki+length(featuresPVsignal);
for i=1:length(featuresTVsignal)
    types(i+ki,3)=1;
    dataAllsignals{i+ki}=featuresTVsignal{i};
    SomeFeatures(i+ki,:)=featuresTV(i,:);
    OutsAll(i+ki)=OutsTV(i);
    oOutsAll(i+ki)=oOutsTV(i);
    patientsAll(i+ki)=PatientsTV(i);
end

ki=ki+length(featuresTVsignal);
for i=1:length(featuresMVsignal)
    types(i+ki,4)=1;
    dataAllsignals{i+ki}=featuresMVsignal{i};
    SomeFeatures(i+ki,:)=featuresMV(i,:);
    OutsAll(i+ki)=OutsMV(i);
    oOutsAll(i+ki)=oOutsMV(i);
    patientsAll(i+ki)=PatientsMV(i);
end

ki=ki+length(featuresMVsignal);
for i=1:length(featuresAVsignal)
    types(i+ki,5)=1;
    dataAllsignals{i+ki}=featuresAVsignal{i};
    SomeFeatures(i+ki,:)=featuresAV(i,:);
    OutsAll(i+ki)=OutsAV(i);
    oOutsAll(i+ki)=oOutsAV(i);
    patientsAll(i+ki)=PatientsAV(i);
end

model={};
modelO={};

% t = templateTree('Reproducible',true);
% Y=OutsAV';Y(Y>1)=1;
% Mdlav = fitcensemble(featuresAV,Y,'OptimizeHyperparameters','auto','Learners',t, ...
%     'HyperparameterOptimizationOptions',struct('AcquisitionFunctionName','expected-improvement-plus'))
% [outs,scores]=model.predict(featuresAV(2:2:end,:));
% model = TreeBagger(300,features,labels);
disp('Training the model...')

nCycles=303;
noReps=3;
YAll=OutsAV;XAll=featuresAV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
model{1}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));

YAll=OutsMV;XAll=featuresMV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
model{2}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));


YAll=OutsPV;XAll=featuresPV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
model{3}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));


YAll=OutsTV;XAll=featuresTV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
model{4}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));
model{5}=compact(fitrensemble(SomeFeatures,OutsAll,'Method','Bag','NumLearningCycles',nCycles));
model{6}=compact(fitrensemble([SomeFeatures,types],OutsAll,'Method','Bag','NumLearningCycles',nCycles));





nCycles=303;

noReps=3;
YAll=oOutsAV;XAll=featuresAV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
modelO{1}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));

YAll=oOutsMV;XAll=featuresMV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
modelO{2}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));


YAll=oOutsPV;XAll=featuresPV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
modelO{3}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));


YAll=oOutsTV;XAll=featuresTV;
X=XAll(1:1:end,:);
Y=YAll(1:1:end);
ff=find(Y>=1);
for k=1:noReps
    X=[X;X(ff,:)];
    Y=[Y,Y(ff)];
end
modelO{4}=compact(fitrensemble(X(:,:),Y,'Method','Bag','NumLearningCycles',nCycles));
modelO{5}=compact(fitrensemble(SomeFeatures,oOutsAll,'Method','Bag','NumLearningCycles',nCycles));
modelO{6}=compact(fitrensemble([SomeFeatures,types],oOutsAll,'Method','Bag','NumLearningCycles',nCycles));

save('modelsBefore.mat','model','modelO','dataAllsignals','OutsAll','SomeFeatures','oOutsAll','patientsAll','types','-v7.3')

[savednet1_A,savednet2_A,snA,err1_1,err2_1,meanDataSignals,stdDataSignals]=trainDeepModelA(dataAllsignals,OutsAll,patientsAll,0,1e-2/3);
[savednet1_both,savednet2_both,sn,err1_v,err2_v]=trainDeepModel(dataAllsignals,SomeFeatures,OutsAll,types,patientsAll,0,1e-2/3);

[savednet1_OA,savednet2_OA,snOA,err1o_1,err2o_1,meanDataSignals,stdDataSignals]=trainDeepModelA(dataAllsignals,oOutsAll,patientsAll,1,1e-2/3);
[savednet1_bothO,savednet2_bothO,snO,err1o_v,err2o_v]=trainDeepModel(dataAllsignals,SomeFeatures,oOutsAll,types,patientsAll,1,1e-2/3);

model{7}=savednet1_A;
model{8}=savednet2_A;
model{9}=savednet1_both;
model{10}=savednet2_both;
model{11}=snA;
model{12}=sn;
model{13}=meanDataSignals;
model{14}=stdDataSignals;

modelO{7}=savednet1_OA;
modelO{8}=savednet2_OA;
modelO{9}=savednet1_bothO;
modelO{10}=savednet2_bothO;
modelO{11}=snOA;
modelO{12}=snO;

% Extracting features and labels
% disp('Extracting features and labels...')
%
% features=[];
% labels_murmur=categorical;
% labels_outcome=categorical;
%
% for j=1:num_patient_files
%
%     fprintf('%d/%d \n',j,num_patient_files)
%
%     current_header=get_header(fullfile(input_directory,patient_files{j}));
%     current_recordings=load_recordings(input_directory,current_header);
%
%     current_features=get_features(current_header, current_recordings);
%     features(j,:) = current_features(:);
%
%     labels_murmur(j)=get_class_murmur(fullfile(input_directory,patient_files{j}));
%     labels_outcome(j)=get_class_outcome(fullfile(input_directory,patient_files{j}));
%
% end
%% train RFs
% model_murmur = TreeBagger(300,features,labels_murmur);
%
% model_outcome = TreeBagger(300,features,labels_outcome);
%
% save_model(model_murmur,classes_murmur,model_outcome,classes_outcome,output_directory);
save_model(model,classes_murmur,modelO,classes_outcome,output_directory);
disp('Done.')

end

function save_model(model_murmur,classes_murmur,model_outcome,classes_outcome,output_directory) %save_PCG_model
% Save results.
filename = fullfile(output_directory,'model.mat');
save(filename,'model_murmur','classes_murmur','model_outcome','classes_outcome','-v7.3');

disp('Done.')
end

function class=get_class_murmur(input_header)

current_header=get_header(input_header);

class=current_header(startsWith(current_header,'#Murmur'));
class=strsplit(class{1},':');
class=strtrim(class{2});

end

function class=get_class_outcome(input_header)

current_header=get_header(input_header);

class=current_header(startsWith(current_header,'#Outcome'));
class=strsplit(class{1},':');
class=strtrim(class{2});

end

function current_header=get_header(input_header)

current_header=fileread(input_header);
current_header=strsplit(current_header,'\n');

end

function current_recordings=load_recordings(input_directory,current_header)

recording_files=get_recording_files(current_header);

current_recordings={};

for j=1:length(recording_files)
    
    current_recordings{j}=audioread(fullfile(input_directory,strtrim(recording_files{j})));
    
end

end

function recording_files=get_recording_files(current_header)

recording_files={};

num_locations=strsplit(current_header{1},' ');
num_locations=str2double(num_locations{2});

for j=2:num_locations+1
    
    current_line=strsplit(current_header{j},' ');
    recording_files{j-1}=current_line{3};
    
end

end

function campaign=get_campaign(header)

campaign=header(startsWith(header,'#Campaign'));
campaign=strsplit(campaign{1},':');
campaign=strtrim(campaign{2});
% weight=str2double(weight);
if strcmp(campaign,'CC2015')
    campaign=0;
else
    if strcmp(campaign,'CC2014')
        campaign=1;
    else
        campaign=2;
    end
end
% if isnan(campaign)
%     campaign=0;
% end

end